//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"

TMemoryStream *gmsFile=NULL;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   ClientSocket1->Address="192.168.16.152";
   ClientSocket1->Port=4000;
   ClientSocket1->Open();
   gmsFile=new TMemoryStream;
}
__fastcall TForm1::~TForm1()
{
   if(gmsFile) delete gmsFile;
   ClientSocket1->Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   TMemoryStream *msFile=new TMemoryStream;
   msFile->LoadFromFile("hand(c2s).jpg");
   MYPACK mp;
   int i=0;
   int block=(msFile->Size%MAX_DATASIZE==0)?
      msFile->Size/MAX_DATASIZE: msFile->Size/MAX_DATASIZE+1;

   for(i=0; i<block; i++)
   {
      if(i==0)
      {
         lstrcpy(mp.szHeader, "FILE-START");
      }
      else if(i==block-1)
      {
         lstrcpy(mp.szHeader, "FILE-END");
      }
      else
      {
         lstrcpy(mp.szHeader, "FILE-CONTINUE");
      }
      lstrcpy(mp.szFileName, "hand(c2s).jpg");
      mp.dwPackTotal=block;
      mp.dwPackCount=i;
      mp.dwTotalDataSize=msFile->Size;
      mp.dwThisDataSize=((i+1)*MAX_DATASIZE>msFile->Size)?
         msFile->Size-i*MAX_DATASIZE: MAX_DATASIZE;
      msFile->Position=i*MAX_DATASIZE;
      msFile->Read(mp.pbThisData, mp.dwThisDataSize);

      ClientSocket1->Socket->SendBuf(&mp, sizeof(MYPACK));
      Sleep(10);
   }
   delete msFile;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocket1Read(TObject *Sender,
      TCustomWinSocket *Socket)
{
   MYPACK mp;
   Socket->ReceiveBuf(&mp, sizeof(MYPACK));

   AnsiString sz=(AnsiString)mp.szHeader;
   if(sz.SubString(1, 4)=="FILE")
   {
      if(sz=="FILE-START")
      {
         gmsFile->Size=mp.dwTotalDataSize;
         gmsFile->Position=0;
      }
      gmsFile->Write(mp.pbThisData, mp.dwThisDataSize);
      if(sz=="FILE-END")
      {
         gmsFile->Position=0;
         gmsFile->SaveToFile(mp.szFileName);
         gmsFile->Clear();
      }
   }
}
//---------------------------------------------------------------------------

